=== packaging/archlinux/PKGBUILD ===
# Contributor: Jeremy Cowgar <jeremy@cowgar.com>
pkgname=efte
pkgver=0.95
pkgrel=1
pkgdesc="Configurable programmers editor"
license=('GPL', 'custom')
url="http://efte.sourceforge.net"
source=(http://downloads.sourceforge.net/sourceforge/$pkgname/$pkgname-$pkgver.tar.gz)
md5sums=('20c5ca30ed1990f473581e6cafda6a4b')
arch=('i686' 'x86_64')

build() {
  cd $startdir/src/$pkgname-$pkgver
  cmake -DBUILD_X=ON -DBUILD_CONSOLE=ON -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INSTALL_PREFIX=/usr . || return 1
  make || return 1
  make DESTDIR=$startdir/pkg install || return 1

  mkdir -p $startdir/pkg/usr/share/licenses/efte || return 1
  cp Artistic $startdir/pkg/usr/share/licenses/efte || return 1

  cd $startdir/pkg/usr/share/efte
  ../../bin/cefte config/mymain.fte system.fterc || return 1
}
