=== packaging/macports/Portfile ===
# $Id$
PortSystem 1.0

name            efte
version         0.95
categories      editors
platforms       darwin
maintainers     jeremy@cowgar.com
description     configurable programmers editor
long_description \
    eFTE is a lightweight, extendable, folding text editor \
    geared toward the programmer. eFTE is a fork of FTE with goals of \
    taking FTE to the next step, hence, Enhanced FTE.

homepage        http://efte.sourceforge.net
master_sites    http://downloads.sourceforge.net/sourceforge/efte/
checksums       efte-${version}.tar.gz md5 20c5ca30ed1990f473581e6cafda6a4b

depends_build   bin:cmake:cmake

configure.args  -DCMAKE_BUIL_TYPE=Release \
                -DCMAKE_INSTALL_PREFIX:PATH=${prefix} \
                -DUSE_GPM=OFF -DBUILD_CONSOLE=ON -DBUILD_X=OFF

configure {
    system "cd ${worksrcpath} && ${configure.env} cmake ${configure.args} ${worksrcpath}"
}

variant x11 {
    depends_build-append    lib:libX11:XFree86
    configure.args-delete   "-DBUILD_X=OFF"
    configure.args-append   "-DBUILD_X=ON"
}

post-destroot {
    system "cd ${destroot}${prefix}/share/efte && ../../bin/cefte config/mymain.fte system.fterc"
}
